function [c_edges, c_nodes]=find_cluster_edge(adj)
% FIND_CLUSTER_EDGE cluster of findings (edges)
%    clusters=FIND_CLUSTER_EDGE(adjacency) will find cluster of
%    findindgs (edges), using breadth-first search (BFS) of matlab_bgl,
%    where adjacency matrix contains findings in the form of a matrix.
%    
%    written by Cheol E Han, Jan 2, 2013. modified on Feb 1, 2013

nodes=find(sum(adj)>0);
c_nodes=find_cluster_node(nodes,adj);
c_edges=find_edges(c_nodes,adj);
return

function c_edges=find_edges(c_nodes,adj)

c_no=numel(c_nodes);
c_edges=cell(1,c_no);
for i=1:c_no 
    c=c_nodes{i};
    edges=[];
    for j=1:numel(c)
        idx=find(adj(c(j),:)>0);
        idx=idx(idx>c(j));
%         idx=intersect(idx,c);
        edges=[edges;repmat(c(j),numel(idx),1),idx'];
    end
    c_edges{i}=edges;
end
