%% testing find_cluster, using 10 by 10 space.
maxX=10;
edges=[1,2;2,7;2,4;5,6;5,8;5,10;8,10];
% findings should be symmetrical and diagnoal-free adjacency matrix
findings=zeros(maxX,maxX);
for i=1:size(edges,1)
    findings(edges(i,1),edges(i,2))=1;
end
findings=(findings+findings')>0;
for i=1:maxX;findings(i,i)=0;end;
% THE ROUTINE.
tic
c=find_cluster_edge(findings);
toc

% showing results.
x=linspace(0,1,maxX+1)'; com=10*[cos(x*2*pi),sin(x*2*pi)];
colorset=[1 0 0;0 1 0;0 0 1;1 1 0;1 0 1;0 1 1;0,0,0;];nc=size(colorset,1);
figure(1);clf;set(gcf,'Position',[100,200,1200,500]);
subplot(1,2,1);plot(com(:,1),com(:,2),'k.','MarkerSize',10);hold on;axis([-12 12 -12 12]);axis equal;
for j=1:maxX;h=text(com(j,1),com(j,2),num2str(j));set(h,'FontSize',20);end;
for j=1:size(edges,1); plot(com(edges(j,:),1),com(edges(j,:),2),'Color',[0.5 0.5 0.5]);end
subplot(1,2,2);plot(com(:,1),com(:,2),'k.','MarkerSize',10);hold on;axis([-12 12 -12 12]);axis equal;
for j=1:maxX;h=text(com(j,1),com(j,2),num2str(j));set(h,'FontSize',20);end;
map=zeros(maxX,maxX);
for i=1:length(c)
    if i>nc;fprintf(1,'warning: more than %d clusters\n',nc);end;
    edge=c{i};
    for j=1:size(edge,1);
        map(edge(j,1),edge(j,2))=i;
        plot(com(edge(j,:),1),com(edge(j,:),2),'Color',colorset(i,:));
    end
end
figure(2);clf;set(gcf,'Position',[100,200,1200,500]);
subplot(1,2,1);imagesc(findings);axis equal;axis tight;
subplot(1,2,2);imagesc(map);axis equal;axis tight
