function cluster=find_cluster_node(nodes, adj)
% FIND_CLUSTER_NODE cluster of findings (nodes)
%    clusters=FIND_CLUSTER_NODE(findings, adjacency) will find cluster 
%    of findindgs (nodes), using breadth-first search (BFS) of matlab_bgl,
%    where adjacency matrix contains information of lay-out, which 
%    can be connectivity network, or spatial relationship.
%    
%    written by Cheol E Han, Jan 2, 2013, modified on Feb 1, 2013

adj_t=sparse(adj(nodes,nodes));
nodes_set=ones(1,numel(nodes));
cluster=cell(0,1);
while sum(nodes_set)>0
    i=find(nodes_set,1,'first');
    c= bfs(adj_t, i)>=0 ;         % BFS.
    nodes_set(c)=0;               % excludes already clustered nodes 
    cluster{end+1}=nodes(c);
end
